#!/bin/bash

# Setup the users Linux environment so that they may run Juno Waves GSE
# software 

pathmunge () {
	if ! echo $PATH | /bin/egrep -q "(^|:)$1($|:)" ; then
	   if [ "$PATH" = "" ] ; then
	      PATH=$1
	   else
	      PATH=$1:$PATH
	   fi
	fi
}

libpathmunge () {
	if ! echo $LD_LIBRARY_PATH | /bin/egrep -q "(^|:)$1($|:)" ; then
	   if [ "$LD_LIBRARY_PATH" = "" ] ; then
	      LD_LIBRARY_PATH=$1
	   else
	      LD_LIBRARY_PATH=$1:$LD_LIBRARY_PATH
	   fi
	fi
}

pypathmunge () {
	if ! echo $PYTHONPATH | /bin/egrep -q "(^|:)$1($|:)" ; then
	   if [ "$PYTHONPATH" = "" ] ; then
	      PYTHONPATH=$1
	   else
	      PYTHONPATH=$1:$PYTHONPATH
	   fi
	fi
}

ARCH=$(uname -s).$(uname -p)

PREFIX=/opt/project/juno/$ARCH
export PREFIX

if [ "$WAVES_DATA" = "" ]; then
	WAVES_DATA=/opt/project/juno/data
	export WAVES_DATA
fi	

pathmunge $PREFIX/bin
libpathmunge $PREFIX/lib64
libpathmunge /usr/local/pgplot

PYVER=$(python -c "import sys; print '.'.join( sys.version.split()[0].split('.')[:2] )")
#"
pypathmunge $PREFIX/lib64/python$PYVER

PGPLOT_DIR=/usr/local/pgplot

export PATH
export LD_LIBRARY_PATH
export PYTHONPATH
export PGPLOT_DIR

# General Java Based software for juno
pathmunge /opt/project/juno/Java/bin

# FEI Client setup, for all POSIX operating systems
pathmunge /opt/project/juno/Java/FEI/latest/bin
FEI5=/opt/project/juno/Java/FEI/latest/config

export FEI5

umask 007








