/** @file JWaves.h Rollup header for all of the JWaves library componets */

#include <jwaves/JWavesDefs.h>
#include <jwaves/JWavesStore.h>
#include <jwaves/JWavesPkt.h>
#include <jwaves/JWavesChanMgr.h>

#include <jwaves/JWavesSDSblk.h>
#include <jwaves/JWavesMroBlk.h>
#include <jwaves/JWavesCCSDSblk.h>
#include <jwaves/JWavesHrbhBlk.h>

#include <jwaves/JWavesRdrBlk.h>
#include <jwaves/JWavesLRSblk.h>
#include <jwaves/JWavesHRSblk.h>
#include <jwaves/JWavesFDMblk.h>

#include <jwaves/JWavesUpkBlk.h>
#include <jwaves/JWavesUsegBlk.h>
#include <jwaves/JWavesDcmpBlk.h>
#include <jwaves/JWavesSideBlk.h>

#include <jwaves/JWavesProc.h>
#include <jwaves/JWavesConv.h>
#include <jwaves/JWavesData.h>

#include <jwaves/JWavesUpkFilter.h>
#include <jwaves/JWavesUsegFilter.h>
#include <jwaves/JWavesDcmpFilter.h>
#include <jwaves/JWavesSideFilter.h>
#include <jwaves/JWavesFilter.h>


/** @defgroup mod_junogse Juno Waves Ground Support Library
 *
 * These structures and functions add a Juno Waves specific extentions to
 * @ref mod_rpwgse.  Most of this documentation is useful as a reference
 * but not as a tutorial.  The following example programs are a more 
 * useful place to start.
 *
 *   - @link waves_read.c @endlink  Reading packets from a file and displaying 
 *      LFR Lo E data bytes in hex.
 *   - @link waves_plot.c @endlink Simple packet plotting using plplot.
 *   - Next Example Here
 */
