/* Swig Definitions for libjwaves wrappers */
%feature("autodoc", "1");

%module jwaves

%include "typemaps.i"

%import rpwgse/Gse.i

%header %{
#include <rpwgse/Gse.h>
#include <jwaves/JWaves.h>

#include <rpwgse/Gse.hpp>

#ifdef __cplusplus
extern "C" {
#endif

static PyObject* g_pJWavesError;
static const except_id_t g_jwaves_catch_spec[] = { {XCEPT_GROUP_ANY, XCEPT_CODE_ANY} }; 

/* WARNING! WARNING! WARNING! This is so not thread safe, don't use the
   rpwgse library from more than one python thread!!! */
static except_t* g_pJWavesExcept = NULL; 
static char g_jwaves_xcept_buf[1024];
#ifdef __cplusplus
}
#endif
%}

/* Define a general exception bouncer from rpwgse to python */
%exception {
	
	except_try_push(g_jwaves_catch_spec, 1, &g_pJWavesExcept);
	
	if( g_pJWavesExcept == 0){
		$action
	}
	else{
		g_jwaves_xcept_buf[1023] = '\0';
		gse_shortprn_except( (char*)g_jwaves_xcept_buf, 1023, g_pJWavesExcept);
		PyErr_SetString(g_pJWavesError, g_jwaves_xcept_buf);
		return NULL;	
	}
	
	except_try_pop();
}

%nodefaultctor;

%include JWavesDefs.i
%include JWavesStore.i
%include JWavesConv.i
%include JWavesRdrBlk.i
%include JWavesMroBlk.i
%include JWavesMultiFileSrc.i


%init %{
	g_pJWavesError = PyErr_NewException("jwaves.error", PyExc_StandardError, NULL);
	Py_INCREF(g_pJWavesError);
	PyModule_AddObject(m, "error", g_pJWavesError);
	
	/* Call Init on module load */
	gse_thread_init(GSE_WARNING, NULL);
%}
