/* JWavesConv.i **************************************************************/

%header %{

char* jwaves_sclk2utc(double dSclk){
	struct timeval tv;
	jwaves_sclk2tv(dSclk, &tv);
	return gse_tv2iso_gm(&tv,GSE_MILLISECS);
}

double jwaves_utc2sclk(const char* sTime)
{
	struct timeval tv;
	
	gse_str2tv_gm(sTime, &tv, true);
	return jwaves_tv2sclk_d(&tv);
}

int jwaves_mp_sclk(int nPktSclk, int nRtiField)
{
	uint2 uRTI = (uint2) (nRtiField & 0xFFFF);
	uint4 uRepSclk = (uint4)nPktSclk;
	uint4 uOutSclk = 0;
	int4 nRet = 0;
	
	uOutSclk = jwaves_recover_sclk(uRTI, uRepSclk);

	/* How to handle error returns ? 
	if( uOutSclk > 0x7FFFFFFF ){
		PyErr_SetString(g_pJWavesError, "SCLK > 0x7FFFFFFF");
		return NULL;
	}
	*/
	
	nRet = (int4) uOutSclk;
	return nRet;
}

%}


double jwaves_str2sclk(const char* sTime);

%newobject jwaves_sclk2utc;
char* jwaves_sclk2utc(double dSclk);

%newobject jwaves_utc2sclk;
double jwaves_utc2sclk(const char* sUTC);

%newobject jwaves_mp_sclk;
int jwaves_mp_sclk(int nPktSclk, int nRtiField);
