/** @file JWavesExcept.h */
#ifndef _JWavesExcept_H_
#define _JWavesExcept_H_

#include <rpwgse/GseExcept.h>

#ifdef __cplusplus
extern "C" {
#endif

/** @addtogroup mod_junogse */
/*@{*/
/** @defgroup mod_jwaves_xcept Exceptions 
 *
 * Exception definitions.
 */
/*@}*/

/** @addtogroup mod_jwaves_xcept */
/*@{*/
/** Exception group for the Juno Waves Ground processing software */
#define JW_XCEPT 11

/** A required preprocessing step has not been preformed on a packet */
#define JW_XPKTNOTREADY   1 

/** An operation requiring science data was requested on a packet that 
    does not contain understandable science data */
#define JW_XPKTNOTSCI     2

/** The Packet ID and Src fields indicate an unknown packet type. */
#define JW_XPKTUNKNOWN    3

/** A packet with sub components does not have a proper number of samples */
#define JW_XNUMPTS        4

/** A 9-bit data format packet has a packet length that is not an even
    number of samples */
#define JW_XFRACSAMPLE    5

/** A catch all for wierd stuff in packed headers */
#define JW_XINVHDRFIELD   10
	
/** Functionality is not there */
#define JW_XNOTYETIMP     99

/*@}*/


#ifdef __cplusplus
}
#endif

#endif /* _JWavesExcept_H_  */
