/** @file JWavesFDMblk.h */
#ifndef _JWavesFDMblk_H_
#define _JWavesFDMblk_H_

#include <jwaves/JWavesRdrBlk.h>

/** @addtogroup mod_jwaves_pkt */
/*@{*/

#ifdef __cplusplus
extern "C" {
#endif

/** Encoder/Decoder for Waves SCE, FDM reader blocks 
 * @class JWavesFDMblk
 * @extends JWavesRdrBlk
 */
typedef struct jwaves_fdm_blk{
	
	/** Base structure */
	JWavesRdrBlk base;
	
	/** FIELD:  Does the filename field cantain a truncated name? */
	bool bTrunc;
	
	/** FIELD:  The number of bytes in each character, either 1 or 2 */
	byte uCharWidth;
	
	/** FIELD:  The basename of the input file for this packet */
	char* sFileName;
		
	/** Destructor */
	void (*del)(void* vpThis);
	
} JWavesFDMblk;

/** Generate a new Juno Waves JPL FDM intermediate file Reader Processing Block
 * @public
 * @memberof JWavesFDMblk
 */
JWavesFDMblk* new_JWavesFDMblk(cbytebuf_t buf, size_t uOver);


/*@}*/
		
#ifdef __cplusplus
}
#endif


#endif /* _JWavesFDMblk_H_ */
