/** @file JWavesLRSblk.h */
#ifndef _JWavesHRSblk_H_
#define _JWavesHRSblk_H_

#include <jwaves/JWavesRdrBlk.h>

/** @addtogroup mod_jwaves_pkt */
/*@{*/

#ifdef __cplusplus
extern "C" {
#endif

/** Encoder/Decoder for Waves SCE, HRS reader blocks 
 * @class JWavesHRSblk
 * @extends JWavesRdrBlk
 */
typedef struct jwaves_hrs_blk{
	
	/** Base structure */
	JWavesRdrBlk base;
	
	/** FIELD: Lower 24 bits of the user UID on the system that read the data */
	uint4 uUID;
	
	/** FIELD: Remote (SCE) socket IP */
	uint4 uRemoteIP;
	
	/** FIELD: Local (Workstation) socket IP */
	uint4 uLocalIP;
	
	/** FIELD: HRS sync */
	byte sync[4];
		
	/** Destructor */
	void (*del)(void* vpThis);
	
} JWavesHRSblk;

/** Generate a new Juno Waves SCE LRS Reader Processing Block 
 * @public
 * @memberof JWavesHRSblk
 */
JWavesHRSblk* new_JWavesHRSblk(cbytebuf_t buf, size_t uOver);


/*@}*/
		
#ifdef __cplusplus
}
#endif


#endif /* _JWavesHRSblk_H_ */
