/* JWavesMroBlk.i */

%rename(JWavesMroBlk) cJWavesMroBlk;
%newobject cJWavesMroBlk::copy();

%header %{

#include <jwaves/JWavesMroBlk.hpp>

cJWavesMroBlk::cJWavesMroBlk() : 
	cGseBlock((GseBlock*)new_JWavesMroBlk(CBBUF_NULL)){
}

cJWavesMroBlk::cJWavesMroBlk(cbytebuf_t buf) :
	cGseBlock( (GseBlock*)new_JWavesMroBlk(buf) ){
}

cJWavesMroBlk::cJWavesMroBlk(GseBlock* pOther) : cGseBlock(pOther) { }

byte cJWavesMroBlk::modBy(){ return ((JWavesMroBlk*)m_pBlk)->uModStep; }

byte cJWavesMroBlk::colRti(){ return ((JWavesMroBlk*)m_pBlk)->uColRTI; }

uint4 cJWavesMroBlk::colSclk(){ return ((JWavesMroBlk*)m_pBlk)->uColSCLK; }

uint2 cJWavesMroBlk::idpCrc(){ return ((JWavesMroBlk*)m_pBlk)->uIDP_CRC; }

uint2 cJWavesMroBlk::idpSeqNo(){ return ((JWavesMroBlk*)m_pBlk)->uSeqNo; }

jwaves_tlm_src cJWavesMroBlk::tlmSrc(){ return ((JWavesMroBlk*)m_pBlk)->uTs; }

uint4 cJWavesMroBlk::idpSclk(){ return ((JWavesMroBlk*)m_pBlk)->uRepSclk; }

uint2 cJWavesMroBlk::origMPlen(){ return ((JWavesMroBlk*)m_pBlk)->uMPlen; }

uint2 cJWavesMroBlk::origMPrti(){ return ((JWavesMroBlk*)m_pBlk)->uMPrti; }

byte cJWavesMroBlk::frame(){ return ((JWavesMroBlk*)m_pBlk)->uFrame; }

byte cJWavesMroBlk::region(){ return ((JWavesMroBlk*)m_pBlk)->uReg; }

uint4 cJWavesMroBlk::address(){ return ((JWavesMroBlk*)m_pBlk)->uAddress; }

cbytebuf_t cJWavesMroBlk::msfBytes(){
	cbytebuf_t buf;
	buf.ptr = ((JWavesMroBlk*)m_pBlk)->MSFary;
	buf.len = ((JWavesMroBlk*)m_pBlk)->uMSFlen;
	return buf;
}

cGseBlock* cJWavesMroBlk::copy(){
	GseBlock* pNewCobj = m_pBlk->copy(m_pBlk, 0);
	return (cGseBlock*) new cJWavesMroBlk(pNewCobj);
}

cJWavesMroBlk* cast_JWavesMroBlk(cGseBlock* pBlk){
	if(pBlk->type() != JW_MRO_BLK_TYPE_ID){
		gse_throw_fm(GSE_XCEPT, GSE_XBADARG, "Can't cast blocks of type 0x%02X"
		          " to a JWavesMroBlk.",  pBlk->type());
	}
	return (cJWavesMroBlk*)pBlk;
}

%}

%include "jwaves/JWavesMroBlk.hpp"
