#############################################################################
# Random comment to test SVN depth commands

from distutils.core import setup, Extension
from subprocess import Popen, PIPE
import os
import sys

perr = sys.stderr.write

sPyVer = '%d.%d'%( sys.version_info[0], sys.version_info[1])


##############################################################################

if not os.getenv('BUILD_DIR'):
	perr("Build products area net defined, set the BUILD_DIR env. var.\n")
	sys.exit(7)

sBuildDir = os.getenv('BUILD_DIR')


if not os.getenv('INST_NAT_LIB'):
	perr("Don't know where to find Native project libraries, INST_NAT_LIB not defined\n")
	sys.exit(7)

sNatLibDir = os.getenv('INST_NAT_LIB');
		
if not os.getenv('INST_INC'):
	perr("Don't know where to find project C header files, INST_INC is not defined\n")
	sys.exit(7)
	
sIncDir = os.getenv('INST_INC')
		
if not os.getenv('INST_EXT_LIB'):
	perr("Don't know where to put python extension objects, INST_EXT_LIB not defined\n")
	sys.exit(7)

sExtLibDir = os.getenv('INST_EXT_LIB');


##############################################################################
# Add source files here

lSrc = ['JWaves_wrap.cpp']
sMod = 'jwaves'
sDesc = "Wrappers for libjwaves library in support of the Juno Waves instrument"
lInc = ['.', sIncDir]

lLibDirs = [sNatLibDir, sExtLibDir]
	
lLib = ['jwaves_t', 'rpwgse_t']
lDefs = [('GSE_POSIX_THREADS', None)]

##############################################################################
# A generic version reporting block

def stripSVNkey(s):
	if s.find(':') == -1:
		return s.strip(" $") + ": unknown"
	else:
		return s.strip(' $')/opt/project/juno/lib/centos6.x86_64/ppd/ppd_jwaves.so

g_sRev = stripSVNkey("$Rev$")
g_sURL = stripSVNkey("$URL$")
g_sWho = stripSVNkey("$LastChangedBy$")
g_sWhen = stripSVNkey("$LastChangedDate$")

##############################################################################
lSources = [ "%s/%s"%(sBuildDir, sSrc) for sSrc in lSrc]

the_mod = Extension('_' + sMod, sources=lSources, include_dirs=lInc, 
                    library_dirs=lLibDirs, libraries=lLib,
						  runtime_library_dirs=lLibDirs, define_macros=lDefs,
						  extra_objects=[ '%s/_rpwgse.so'%lLibDirs[1] ] )

setup( name=sMod, version=g_sRev, author=g_sWho, description=sDesc,
       ext_modules = [the_mod], py_modules = [sMod] )

