#define _POSIX_C_SOURCE 200112

#ifdef GSE_POSIX_THREADS
#include <pthread.h>
#endif

#include <assert.h>
#include <stdlib.h>

#include "GseWrap.h"
#include "GseArrays.h"

/*****************************************************************************/
/* Need explicit instanitaiton of the GseBufAry macro template,              */
/* In this case when a pointer is removed from the array do not call free or */
/* del for the pointer                                                       */

#define C GseBufAry
#define T bytebuf_t

#define EQUALS(a, b)  ( (a.ptr == b.ptr)&&(a.len == b.len) )

#include "aryTplt.c"

#undef EQUALS
#undef C
#undef T

void GseBufAry_cleanup(void* vpBufAry)
{
	size_t i;
	GseBufAry* p = (GseBufAry*)vpBufAry;
	
	for(i = 0; i<p->num; i++)
		if( p->pAry[i].ptr != NULL)
			free(p->pAry[i].ptr);
	
	p->del(p);	
}


/* Dynamic Double Arrays */

#define C GseFloat8Ary
#define T float8

#include "aryTplt.c"

#undef C
#undef T

/* Dynamic Integer Arrays */

#define C GseInt4Ary
#define T int4

#include "aryTplt.c"

#undef C
#undef T

/* Dynamic uint2 Arrays */

#define C GseUint2Ary
#define T uint2

#include "aryTplt.c"

#undef C
#undef T
