/** @file GseArrays.h Arrays of buffers */
#ifndef _GseArrays_H_
#define _GseArrays_H_

#include <rpwgse/GseTypes.h>

#ifdef __cplusplus
extern "C" {
#endif

/** @addtogroup mod_types */
/*@{*/

#define S gse_buf_ary
#define C GseBufAry
#define T bytebuf_t

/* Note, the included file has doxygen documentation that is automatically
   extracted via doc_filter.py at the top level */
#include "aryTplt.h"

#undef S
#undef C
#undef T

/** Cleanup handler for arrays of bytebuf_t.
 * Suitable for use in except_cleanup_push.
 * @param vpBufAry a pointer to a GseBufAry allocated on the heap.
 * @memberof GseBufAry
 */
void GseBufAry_cleanup(void* vpBufAry);


/* Dynamic Double Arrays */

#define S gse_float8_ary
#define C GseFloat8Ary
#define T float8

#include "aryTplt.h"

#undef S
#undef C
#undef T

/* Dynamic Integer Arrays */

#define S gse_int4_ary
#define C GseInt4Ary
#define T int4

#include "aryTplt.h"

#undef S
#undef C
#undef T

/* Dynamic uint2 arrays */
#define S gse_uint2_ary
#define C GseUint2Ary
#define T uint2

#include "aryTplt.h"

#undef S
#undef C
#undef T



/*@}*/

#ifdef __cplusplus
}
#endif

#endif /* _GseArrays_H_ */
