/* GseBlock.i */

%rename(GseBlock) cGseBlock;
%newobject cGseBlock::copy();

%header %{
#include <rpwgse/GseBlock.hpp>

/* This is a pain but it is re-usable... */
cGseBlock::cGseBlock(){
	m_pBlk = new_GseBlock(CBBUF_NULL, 0);
	m_bOwner = true;
}
cGseBlock::cGseBlock(cbytebuf_t buf, size_t uOverMalloc){
	m_pBlk = new_GseBlock(buf, uOverMalloc);
}
cGseBlock::cGseBlock(GseBlock* pWrap){
	m_pBlk = pWrap;  /* Takes ownership of C object */
}
cGseBlock::~cGseBlock(){
	if(m_bOwner) 
		m_pBlk->del(m_pBlk);	
}

const char* cGseBlock::name(){ return m_pBlk->name(m_pBlk); }

byte cGseBlock::type(){ return m_pBlk->uType; }

byte cGseBlock::length(){ return m_pBlk->uLen; }

cbytebuf_t cGseBlock::original(){ return m_pBlk->original(m_pBlk); }


cGseBlock* cGseBlock::copy(){
	GseBlock* pNewCobj = m_pBlk->copy(m_pBlk, 0);
	return  new cGseBlock(pNewCobj);
}

bool cGseBlock::isOwner(){ return m_bOwner; }

%}

%include rpwgse/GseBlock.hpp
