/** @file GseField.hpp C++ interface to GseField structures */

#ifndef _GseField_HPP_
#define _GseField_HPP_

#include <rpwgse/GseField.h>
#include <rpwgse/GseProp.hpp>

class cGseField {
public:
	friend class cGseParser;
	
	const char* name() const;
	const char* desc() const;
	char valType() const;
	const char* sval() const;
	float8 fval() const;
	uint8 uval() const;
	int8 ival() const;
	gse_alarm_stat_t alarm() const;
	
	cGseProp* first() const;
	cGseProp* next(const cGseProp* pProp) const;
	cGseProp* getProp(const char* sName) const;
	bool hasProp(const char* sName) const;
	gse_prop_type_t getPropType(const char* sName) const;
	
	~cGseField();

protected:
	cGseField(const GseField* pWrap);
	const GseField* m_pField;   /* The wrapper NEVER owns the cObj */
};

#endif /* _GseField_HPP_ */
