/* GseLog.h ******************************************************************/
#define GSE_EVERYTHING   0

#define GSE_TRACE       20
#define GSE_DEBUG       30
#define GSE_NOTICE      40
#define GSE_INFO        40
#define GSE_WARNING     50
#define GSE_ERROR       60
#define GSE_CRITICAL    70

#define GSE_NOTHING    100

int gse_log_setlevel(int nLevel);
int gse_log_getlevel();

void gse_log_msg(int nLevel, const char* sMsg);

%pythoncode %{

class GseLogger(object):
	def __init__(self, sLevel):
		self.nLevel = GSE_EVERYTHING
	
		if sLevel == None or len(sLevel) < 1:
			raise ValueError("Unknown log level '%s'"%sLevel)
		
		if sLevel.lower() == "trace":
			self.nLevel = GSE_TRACE
		elif sLevel.lower() == "debug":
			self.nLevel = GSE_DEBUG
		elif sLevel.lower() == "notice" or sLevel.lower() == "info":
			self.nLevel = GSE_NOTICE
		elif sLevel.lower() == "warning":
			self.nLevel = GSE_WARNING
		elif sLevel.lower() == "error":
			self.nLevel = GSE_ERROR
		elif sLevel.lower() == "critical":
			self.nLevel = GSE_CRITICAL
			
		gse_log_setlevel(self.nLevel)

	def trace(self, sMsg):
		gse_log_msg(GSE_TRACE, sMsg)
	
	def debug(self, sMsg):
		gse_log_msg(GSE_DEBUG, sMsg)

	def notice(self, sMsg):
		gse_log_msg(GSE_NOTICE, sMsg)

	def info(self, sMsg):
		gse_log_msg(GSE_INFO, sMsg)

	def warning(self, sMsg):
		gse_log_msg(GSE_WARNING, sMsg)

	def error(self, sMsg):
		gse_log_msg(GSE_ERROR, sMsg)

	def critical(self, sMsg):
		gse_log_msg(GSE_CRITICAL, sMsg)

%}
