#define _POSIX_C_SOURCE 200112

#ifdef GSE_POSIX_THREADS
#include <pthread.h>
#endif

#include <math.h>
#include <errno.h>

#include "GseMath.h"
#include "GseExcept.h"

float8 gse_lerp(float8 x0, float8 x1, float8 y0, float8 y1, 
                      float8 x_interp)
{
	
	if((x1 - x0) == 0.0)
		gse_throw(GSE_XCEPT, GSE_XDIVZERO);
	
	return y0 + (x_interp - x0)*( (y1 - y0)/(x1 - x0) );
}

float8 gse_log10_sub(float8 val, float8 sub){
	if(val == 0.0) return sub;
	return log10(val);
}

float8 gse_sqrt(float8 x)
{
	if(x < 0) 
		gse_throw(CLIB_XCEPT, EDOM);
	return sqrt(x);
}

float8 gse_log10(float8 x)
{
	if(x == 0.0) 
		gse_throw(CLIB_XCEPT, ERANGE);
	if(x < 0.0) 
		gse_throw(CLIB_XCEPT, EDOM);
	return log10(x);
}

float8 gse_pow(float8 x, float8 y)
{
	float8 intPart;
	
	if((x < 0.0) && (modf(y, &intPart) != 0.0))
		gse_throw(CLIB_XCEPT, EDOM);
	
	return pow(x,y);
}
