/* @file GseParser.hpp C++ interface to GseParser structures */

#ifndef _GseParser_HPP_
#define _GseParser_HPP_

#include <rpwgse/GseParser.h>
#include <rpwgse/GseField.hpp>

class cGseParser {
public:
	cGseParser(GseParser* pWrap);
	
	const char* name() const;
	bool hasField(const char* sName) const;
	cGseField* getField(const char* sName) const;
	cGseField* firstField() const;
	cGseField* nextField(const cGseField* pField) const; 
	char* read(cbytebuf_t cbuf);
	bool hasProp(const char* sName) const;
	cGseProp* getProp(const char* sName) const;
	~cGseParser();
	
protected:
	GseParser* m_pParser;
};



#endif /* _GseParser_HPP_ */
