/* C++ interface to the packet class */

#ifndef cGsePkt_HPP_
#define cGsePkt_HPP_

class cGsePkt {
public:
	cbytebuf_t getData();
	void setData(bytebuf_t dataBuf);
	bool hasUniqueBlkByType(byte uType, byte uProc);
	
	/* C sturcture is shared by return object and the packet */
	cGseBlock* getBlkByTypeIdx(byte uType, byte uProc, int4 idx);
	
	/* C sturcture is shared by return object and the packet */
	cGseBlock* getBlkByType(byte uType, byte uProc);
	
	int addHdrBlk(cGseBlock* pBlk);
	bool testEncode(int nLevel=GSE_ERROR);
	bytebuf_t encode();
	const GseHdr* getHdr();
	
	virtual cGsePkt* copy();
	virtual ~cGsePkt();
	
	cGsePkt(GsePkt* pWrapMe);
	
protected:
	cGsePkt();
	GsePkt* m_pPkt;  /* The wrapped C structure */
};

#endif /* cGsePkt_HPP_ */
