/* GsePkt.i */

%rename(GsePkt) cGsePkt;
%newobject cGsePkt::copy();
%newobject cGsePkt::getBlkByTypeIdx(byte uType, byte uProc, int4 idx);
%newobject cGsePkt::getBlkByType(byte uType, byte uProc);

%header %{
#include <rpwgse/GsePkt.hpp>

cGsePkt::cGsePkt(){ m_pPkt = new_empty_GsePkt(0); }

cGsePkt::cGsePkt(GsePkt* pWrapMe){ m_pPkt = pWrapMe; }

cGsePkt* cGsePkt::copy(){
	GsePkt* pNewCobj = m_pPkt->copy(m_pPkt, 0);
	return new cGsePkt(pNewCobj);
}

cGsePkt::~cGsePkt(){
	m_pPkt->del(m_pPkt);
}

cbytebuf_t cGsePkt::getData(){ return m_pPkt->getData(m_pPkt); }

void cGsePkt::setData(bytebuf_t dataBuf){
	m_pPkt->setData(m_pPkt, dataBuf);
}

bool cGsePkt::hasUniqueBlkByType(byte uType, byte uProc){
	return m_pPkt->hasUniqueBlkByType(m_pPkt, uType, uProc);
}

cGseBlock* cGsePkt::getBlkByTypeIdx(byte uType, byte uProc, int4 idx){
	const GseBlock* pCblk = m_pPkt->getBlkByTypeIdx(m_pPkt, uType, uProc, idx);
	 
	/* Cast away the const, but remember we aren't the memory owner */
	cGseBlock* pBlk = new cGseBlock((GseBlock*)pCblk);
	pBlk->m_bOwner = false;
	return pBlk;
}

cGseBlock* cGsePkt::getBlkByType(byte uType, byte uProc){
	const GseBlock* pCblk = m_pPkt->getBlkByType(m_pPkt, uType, uProc);
	 
	/* Cast away the const, but remember we aren't the memory owner */
	cGseBlock* pBlk = new cGseBlock((GseBlock*)pCblk);
	pBlk->m_bOwner = false;
	return pBlk;
}

int cGsePkt::addHdrBlk(cGseBlock* pBlk){
	
	if(! pBlk->isOwner() ){
		gse_throw_m(GSE_XCEPT, GSE_XBADARG, "CPP wrapper doesn't own the "
		           "underlying C GsePkt structure, and thus can't give "
						"ownership to the GsePkt object. (Should have used Java!)");
	}
	
	pBlk->m_bOwner = false;
	return m_pPkt->addHdrBlk(m_pPkt, pBlk->m_pBlk);
}

bool cGsePkt::testEncode(int nLevel){
	return m_pPkt->testEncode(m_pPkt, nLevel);
}

bytebuf_t cGsePkt::encode(){ return m_pPkt->encode(m_pPkt); }

const GseHdr* cGsePkt::getHdr(){ return m_pPkt->pHdr; }

%}

%include "rpwgse/GsePkt.hpp"

