#define _POSIX_C_SOURCE 200112

#ifdef GSE_POSIX_THREADS
#include <pthread.h>
#endif

#include "GsePktSrc.h"
#include "GseExcept.h"
#include "GseWrap.h"

bool GsePktSrc_false(const GsePktSrc* pThis){ return false; }

uint4 GsePktSrc_setMaxPktSz(GsePktSrc* pThis, uint4 uMax)
{
	uint4 uOld = pThis->uMaxPktSz;
	pThis->uMaxPktSz = uMax;
	return uOld;
}

uint4 GsePktSrc_getMaxPktSz(const GsePktSrc* pThis)
{
	return pThis->uMaxPktSz;
}


GsePktSrc* new_GsePktSrc(size_t uMalloc)
{
	GsePktSrc* pThis = NULL;
	
	if(uMalloc <= sizeof(GsePktSrc))
		gse_throw_m(GSE_XCEPT, GSE_XBADARG, "GsePktSrc is a virtual base, "
				      "thus uMalloc must be greater than sizeof(GsePktSrc)");


	pThis = (GsePktSrc*) gse_calloc(1, uMalloc);
	
	pThis->uMaxPktSz = 2147483648;   /* 2^31 */
	pThis->setMaxPktSz = GsePktSrc_setMaxPktSz;
	pThis->getMaxPktSz = GsePktSrc_getMaxPktSz;
	
	/* Say that nothing is supported, until derived class turns it on */
	pThis->supportsPrev      = GsePktSrc_false;
	pThis->supportsRewind    = GsePktSrc_false;
	pThis->supportsSkipAhead = GsePktSrc_false;
	pThis->supportsSkipBack  = GsePktSrc_false;
	
	
	pThis->del = NULL;  /* This is a virtual base so BYOD */

	return pThis;	
}
