/* GseProcBlk.i */

%rename(GseProcBlk) cGseProcBlk;
%newobject cGseProcBlk::copy();

%header %{

#include <rpwgse/GseProcBlk.hpp>

cGseProcBlk::cGseProcBlk():
   cGseBlock( (GseBlock*)new_GseProcBlk(CBBUF_NULL, 0) ){ 
}
	
cGseProcBlk::cGseProcBlk(cbytebuf_t buf, size_t uOverMalloc):
	cGseBlock( (GseBlock*)new_GseProcBlk(buf, uOverMalloc) ){
}
	
cGseProcBlk::cGseProcBlk(byte uStepID, byte uProgID, uint4 uBegSec, uint2 uBegMicroSecDiv100):
	cGseBlock(  (GseBlock*) new_GseProcBlk2(uStepID, uProgID, uBegSec, uBegMicroSecDiv100) ){
}
	
cGseProcBlk::cGseProcBlk(GseBlock* pOther) : cGseBlock(pOther){
}
	
void cGseProcBlk::setNow(){
	((GseProcBlk*)m_pBlk)->setNow((GseProcBlk*)m_pBlk);
}

byte cGseProcBlk::stepID(){ return ((GseProcBlk*)m_pBlk)->uStepID; }

byte cGseProcBlk::progID(){ return ((GseProcBlk*)m_pBlk)->uProgID; }
	
uint8 cGseProcBlk::microEpoch(){
	return ((GseProcBlk*)m_pBlk)->microEpoch((GseProcBlk*)m_pBlk);
}

uint4 cGseProcBlk::begSec(){ return ((GseProcBlk*)m_pBlk)->uBegSec; }

uint4 cGseProcBlk::begMicroSec(){
	return ( ((GseProcBlk*)m_pBlk)->uBegUSecDiv100 * 100);
}
	
byte cGseProcBlk::errors(){ return ((GseProcBlk*)m_pBlk)->uErrors; }

byte cGseProcBlk::warnings(){ return ((GseProcBlk*)m_pBlk)->uWarnings; }

void cGseProcBlk::setErrors(byte uErrors){
	((GseProcBlk*)m_pBlk)->uErrors = uErrors;
}

void cGseProcBlk::setWarnings(byte uWarnings){
	((GseProcBlk*)m_pBlk)->uWarnings = uWarnings;

}

cGseBlock* cGseProcBlk::copy(){
	GseBlock* pNewCobj = m_pBlk->copy(m_pBlk, 0);
	return (cGseBlock*) new cGseProcBlk(pNewCobj);
}
	
cGseProcBlk* cast_GseProcBlk(cGseBlock* pBlk){ 
	return (cGseProcBlk*)pBlk;
}
%}

%include rpwgse/GseProcBlk.hpp
