#define _POSIX_C_SOURCE 200112

#ifdef GSE_POSIX_THREADS
#include <pthread.h>
#endif

#ifndef __sun
#error Only compile this file on Solaris
#endif

#include <ucontext.h>

struct ptr_store{
	void** buf;
	int len;
	int size;
};


int save_callback(uintptr_t pAddr, int nSignal, void* vpStore)
{
	struct ptr_store* pStore;
	pStore = (struct ptr_store*)vpStore;
	
	if(pStore->len >= pStore->size) return -1;
	
	*(pStore->buf + pStore->len) = (void*)pAddr;
	pStore->len += 1;
	
	return 0;
}

int backtrace(void** buffer, int size)
{
	ucontext_t ctx;
	
	struct ptr_store store;
	store.buf = buffer;
	store.size = size;
	store.len = 0;
	
	if(getcontext(&ctx) < 0) return 0;
	
	walkcontext(&ctx, save_callback, (void*)(&store));
	
	return store.len;
}
