/** @file GseSunSvc.h */
#ifndef _GseSunSvc_H_
#define _GseSunSvc_H_

#ifdef __cplusplus
extern "C" {
#endif

/** @addtogroup mod_rpwgse */
/*@{*/

/** @defgroup mod_sun_svc Solaris Helpers
 * Provides some needed functionality that is no available by default from
 * the Solaris 10 System libraries
 */
/*@}*/

/** @addtogroup mod_win_svc */
/*@{*/

/** A Solaris implementation of the handy GNU backtrace function. 
 *
 * @param buffer a void pointer array to contain the function addresses.
 * @param size the maximum number of function address to store in buffer.
 * @return The number of function addresses returned in buffer.
 */
int backtrace(void** buffer, int size);

/*@}*/

#ifdef __cplusplus
}
#endif

#endif /* _GseSunSvc_H_ */
