#define _POSIX_C_SOURCE 200112 

#ifdef GSE_POSIX_THREADS
#include <pthread.h>
#endif

#define _GseTypes_C_

#include "GseTypes.h"
#include "GseWrap.h"
#include "GseExcept.h"

cbytebuf_t const_bytebuf(bytebuf_t buf){
	cbytebuf_t cbuf;
	cbuf.len = buf.len;
	cbuf.ptr = (const byte*)buf.ptr;
	return cbuf;
}

const cbytebuf_t CBBUF_NULL = {NULL, 0};
const bytebuf_t BBUF_NULL   = {NULL, 0};


bytebuf_t copy_cbytebuf(cbytebuf_t src)
{
	bytebuf_t dest;
	
	dest.len = src.len;
	if(dest.len > 0){
		if(src.ptr != NULL){
			dest.ptr = (byte*)gse_calloc(dest.len, 1);
			memcpy(dest.ptr, src.ptr, dest.len);
		}
		else
			gse_throw_m(GSE_XCEPT, GSE_XBADARG, "Inconsistant source buffer, len "
					      "is 0 but ptr is not NULL.");
	}
	else
		dest.ptr = NULL;
	
	return dest;
}

bytebuf_t copy_bytebuf(bytebuf_t src)
{
	return copy_cbytebuf(const_bytebuf(src));
}
