/* This library does not expose the bytebuf and charbuf structures to
   the scripting langages, as they already have objects suitable for
	representing a chunk of bytes as well as a length, in python simple
	string objects are more appropriate */ 

typedef long long unsigned int uint8;
typedef long long int int8;

typedef unsigned int uint4;
typedef int int4;

typedef unsigned short int uint2;
typedef short int int2;

typedef signed char int1;
typedef unsigned char uint1;
typedef unsigned char byte;

typedef float float4;
typedef double float8;

/* typedef unsigned long size_t; */

/* typedef struct bytebuf_t{ byte* ptr; size_t len; } bytebuf_t;
typedef struct cbytebuf_t { const byte* ptr; size_t len; } cbytebuf_t; */

#if defined(SWIGPYTHON)

/* Convert a byte pointer and length into a python string */
%typemap(in) (const byte* STRING, size_t LENGTH) {
	$1 = (byte*) PyString_AsString($input);
	$2 = (size_t) PyString_Size($input);
}

/* Convert a python string input into a constant byte buffer object */
%typemap(in) cbytebuf_t (cbytebuf_t buf) {
	buf.ptr = (byte*) PyString_AsString($input);
	buf.len = (size_t) PyString_Size($input);
	$1 = buf;
}

%typemap(typecheck,precedence=SWIG_TYPECHECK_INT64) int8 INPUT {
	$1 = PyLong_CheckExact($input) ? 1 : 0;
}

%typemap(in) int8 INPUT{
	$1 = PyLong_AsLongLong($input);
}

%typemap(out) int8 INPUT{
	$result = PyLong_FromLongLong($1);
}

%typemap(in) uint8 INPUT{
	$1 = PyLong_AsUnsignedLongLong($input);
}

%typemap(out) uint8 INPUT{
	$result = PyLong_FromUnsignedLongLong($1);
}
	
/* Convert a const byte buffer output into a python string */
%typemap(out) cbytebuf_t {
   $result = PyString_FromStringAndSize((const char*)$1.ptr, $1.len);
}

%typemap(typecheck,precedence=SWIG_TYPECHECK_STRING) cbytebuf_t {
	$1 = PyString_Check($input) ? 1 : 0;
}

#else
#error Extend the typemaps in GseTypes.i for your target language
#endif

