#ifndef _MASH_DEF
#define _MASH_DEF
#define _MASH_IN(x, y)  x ## y
#define _MASH(x, y) _MASH_IN(x, y)
#endif /* _MASH */

#include <assert.h>

/* adding values to the array (appending) */

int _MASH(C, _add)(C* pThis, T val){
	
	T* pNewAry = NULL;
	size_t i;
	
	pNewAry = (T*) calloc(pThis->num + 1, sizeof(T));
	
	for(i = 0; i<pThis->num; i++){
		pNewAry[i] = pThis->pAry[i];
	}
	free(pThis->pAry);
	
	pNewAry[pThis->num] = val;

	pThis->num += 1;
	pThis->pAry = pNewAry;
	
	return pThis->num;
}

/* removing item at index i from the array */
int _MASH(C, _rm)(C* pThis, int idx){
	int i, j;
	T* pNewAry = NULL;
	
	assert((idx < 0)||(idx >= pThis->num));
	
	if((idx < 0)||(idx >= pThis->num)){
		return pThis->num;
	}
	
	if(pThis->num == 1){
		(*(pThis->clear))(pThis);
		return 0;
	}
	
	pNewAry = (T*) calloc(pThis->num - 1, sizeof(T));
	
	j = 0;
	for(i = 0; i < pThis->num; i++){
		if(i != idx)
			pNewAry[j] = pThis->pAry[i];
		j++;
	}
	free(pThis->pAry);
	pThis->pAry = pNewAry;
	
	pThis->num -= 1;
	return pThis->num;
}

/* Clearing the entire array */
void _MASH(C, _clear)(C* pThis){
	pThis->num = 0;
	free(pThis->pAry);
	pThis->pAry = NULL;
}

/* destructor */
void _MASH(delete_, C)(C* pThis){
	(*(pThis->clear))(pThis);
	free(pThis);
}

/* Checking to see if a value exists in the array */
int _MASH(C, _has_value)(C* pThis, T val){
	int i;
	
	for(i = 0; i< pThis->num; i++){
#ifdef EQUALS
		 if( EQUALS(pThis->pAry[i], val) ) 
#else
		if(pThis->pAry[i] == val)
#endif
			return 1;
		
	}
	
	return 0;
}

/* Adding a value if it doesn't already exist */
int _MASH(C, _add_unique)(C* pThis, T val){
	
	if(! (*(pThis->has_value))(pThis, val))
		(*(pThis->add))(pThis, val);	
		
	return pThis->num;
}


/* Constructor */

C* _MASH(new_, C) (){
	C* pThis;
	pThis = (C*) malloc(sizeof(C));
	pThis->num = 0;
	pThis->pAry = NULL;
	pThis->del =  _MASH(delete_, C);
	pThis->add =  _MASH(C, _add);
	pThis->rm  =  _MASH(C, _rm);
	pThis->has_value =  _MASH(C, _has_value);
	pThis->add_unique =  _MASH(C, _add_unique);
	pThis->clear =  _MASH(C, _clear);
	
	return pThis;
}
