#include <stdlib.h>


#ifndef _MASH_DEF
#define _MASH_DEF
#define _MASH_IN(x, y) x ## y
#define _MASH(x, y) _MASH_IN(x, y)
#endif /* _MASH_DEF */

/** Generic typed object array structure.
 * This Class was generated from the @ref page_aryTplt.
 * @n @n
 */
typedef struct S{
	/** number of items in the array, automatically updated by #add, #rm 
	    and #del */
	size_t num;
	
	/** Pointer to an array of object of type t */
	T* pAry;
	
	/** point to an array of items of type \a t, automatically mantianed by
	#add, #rm and #del */
	int (*add)(struct S* pThis, T val);
	
	/** remove item at index \a idx from the array */
	int (*rm)(struct S* pThis, int idx);
	
	/** does this value exists in the array */
	int (*has_value)(struct S* pThis, T val);
	
	/** add a value only if it doesn't aready exist in the array */
	int (*add_unique)(struct S* pThis, T val);
	
	/** clear all values from the array */
	void (*clear)(struct S* pthis);
	
	/** delete the array object */
	void (*del)(struct S* pThis);
} C;

/** Creates a new dynamic array structure on the heap. */
C* _MASH(new_, C) ();


