/* Internal definition for the parser builder.  These structures facilitate
   flex any bison interal communications, and are not part of the 
	rpwgse API.
*/

struct gse_psrbldr_state{
	
	/* Input Reading State */
	const char* pStart;
	const char* pCur;
	size_t length;
	
	/* Global item tracking */
	
	/* The lex scanner pointer.  This is kept here so that the Bison parser
	 * can provide the scanner object pointer to reentrant lex scanner
	 * functions */
	void* scanner;
	
	/* The dictionary of parsers that is built up during config parsing */
	GseStrPsrDict* pParsers;
		
	/* The parameter dictionary, consists of properties */
	GseStrPropDict* pParams;
	
	/* Storage for the current value of the default field */
	GseStrPropDict* pDefs;
	
	/* Temporary storage for a single enum item, since enums aren't
	 * Nestable, this is okay */
	bool bEnumDef;
	int8 iEnumVal;
	char* sEnumVal;
	
	/* Storage for any error messages generated by the bison yyparse 
	 * function, allocated on the stack */
	char* sErr;
	
	/* The name of the configuration file, if any.  This may be NULL */
	const char* sFile;
};

void gse_psrbldrlxr_beg(struct gse_psrbldr_state* pState, const char* sConfig);

void gse_psrbldrlxr_end(struct gse_psrbldr_state* pPState);

