#ifndef _MASH_DEF
#define _MASH_DEF
#define _MASH_IN(x, y)  x ## y
#define _MASH(x, y) _MASH_IN(x, y)
#endif /* _MASH */

/* handle the cascade types */

#if  defined (CASCADE_DEL) || defined (CASCADE_FREE)
#define CASCADE
#endif


void _MASH(delete_, C) (void* vpThis){
	C* pThis = vpThis;
#ifdef CASCADE
	int i;
	for(i = 0; i<pThis->num; i++)
#ifdef CASCADE_FREE
		if(pThis->pAry[i] != NULL) free(pThis->pAry[i]);
#else
#ifdef CASCADE_DEL
		if(pThis->pAry[i] != NULL) pThis->pAry[i]->del(pThis->pAry[i]);
#endif /* CASCADE_DEL  */
#endif /* CASCADE_FREE */
#endif /* CASCADE      */
	free(pThis->pAry);
	free(pThis);
}

int _MASH(C, _add)(C* pThis, T* pItem){
	T** pNewAry = NULL;
	int i;
	
	pNewAry = (T**)(gse_calloc(pThis->num+1, sizeof(T*)));
	
	for(i = 0; i< pThis->num; i++)
		pNewAry[i] = pThis->pAry[i];
	free(pThis->pAry);
	
	pNewAry[pThis->num] = pItem;
	
	pThis->num += 1;
	pThis->pAry = pNewAry;
	
	return pThis->num;
}

int _MASH(C, _rm_ptr)(C* pThis, T* pItem){
	int i, j;
	int bHave = 0;
	T** pNewAry;
	
	/* 1st find pointer in array */
	for(i = 0; i< pThis->num; i++){
		if(pThis->pAry[i] == pItem){
			bHave = 1;
			break;
		}
	}
	
	assert(bHave != 0);
	if(bHave != 1)
		return pThis->num;
	
	/* Okay actually removing something */
#ifdef CASCADE
#ifdef CASCADE_FREE
	if(pItem != NULL) free(pItem);
#else
#ifdef CASCADE_DEL
	if(pItem != NULL) pItem->del(pItem);
#endif /* CASCADE_DEL  */
#endif /* CASCADE_FREE */
#endif /* CASCADE      */
	
	pThis->num -= 1;
	
	if(pThis->num == 0){
		free(pThis->pAry);
		pThis->pAry = NULL;
	}
	else{
		pNewAry = (T**)(gse_calloc(pThis->num, sizeof(T*)));
		j = 0;
		for(i = 0; i < pThis->num + 1; i++){
			if(pThis->pAry[i] != pItem){
				pNewAry[j] = pThis->pAry[i];
				j++;
			}
		}
		free(pThis->pAry);
		pThis->pAry = pNewAry;
	}
	
	return pThis->num;
}

void _MASH(C, _sort)(C* pThis, int (*compare)(const void*, const void*))
{
	if(pThis->num < 2) return;
	qsort(pThis->pAry, pThis->num, sizeof(T*), compare);
}

void _MASH(init_, C)(C* pThis, size_t uLen){
	pThis->num = uLen;
	pThis->del =  _MASH(delete_, C);
	pThis->add =  _MASH(C, _add);
	pThis->rm_ptr =  _MASH(C, _rm_ptr);
	pThis->sort = _MASH(C, _sort);
	
	if(uLen > 0)
		pThis->pAry = (T**)gse_calloc(uLen, sizeof(T*));
	else
		pThis->pAry = NULL;
}

C* _MASH(new_, C) (size_t uLen){
	C* pThis;
	pThis = (C*)(malloc(sizeof(C)));
	
	_MASH(init_, C)(pThis, uLen);
	
	return pThis;
}

#undef CASCADE

