#############################################################################
from distutils.core import setup, Extension
from subprocess import Popen, PIPE
import os

sArch = os.getenv("N_ARCH")
if sArch == None:
	raise EnvironmentError("Env. Var. N_ARCH is not defined")
	
sBuildDir = 'build.' + sArch

##############################################################################
sPrefix = os.getenv('PREFIX')
sLibDir = os.getenv('INST_NAT_LIB')
sIncDir = os.getenv('INST_INC')

if sPrefix == None:
	raise EnvironmentError("Env. Var. PREFIX is not defined")

if sIncDir == None:
	raise EnvironmentError("Env. Var. INST_INC is not defined")

if sLibDir == None:
	raise EnvironmentError("Env. Var. INST_NAT_LIB is not defined")
	

##############################################################################
# Add source files here

lSrc = ['Gse_wrap.cpp']
sMod = 'rpwgse'
sDesc = "Wrappers for librpwgse library"
lInc = [sIncDir]

lLibDirs = [sLibDir]
	
lLib = ['rpwgse_t']
lDefs = [('GSE_POSIX_THREADS', None)]

##############################################################################
# A generic version reporting block

def stripSVNkey(s):
	if s.find(':') == -1:
		return s.strip(" $") + ": unknown"
	else:
		return s.strip(' $')

g_sRev = stripSVNkey("$Rev$")
g_sURL = stripSVNkey("$URL$")
g_sWho = stripSVNkey("$LastChangedBy$")
g_sWhen = stripSVNkey("$LastChangedDate$")

##############################################################################
lSources = [ "%s/%s"%(sBuildDir, sSrc) for sSrc in lSrc]

the_mod = Extension('_' + sMod, sources=lSources, include_dirs=['.'], 
                    library_dirs=lLibDirs, libraries=lLib,
						  runtime_library_dirs=lLibDirs, define_macros=lDefs)
						  
setup( name=sMod, version=g_sRev, author=g_sWho, description=sDesc,
       ext_modules = [the_mod], py_modules = [sMod] )

