/* Testing how larger types are cast to smaller types */

#include <stdio.h>

#include <limits.h>
#include "../rpwgse/GseTypes.h"

int main(int argc, char** argv)
{
	/* uint8 u8 = 0x8877665544332211; */
	uint8 u8 =    0x8000000000000000; 
	float8 f8;
	byte b1;
	uint2 u2;
	int8 i8;
	int8 i8tmp;
	byte* pByteU;
	byte* pByte;
	int4 i;
	
	b1 = (byte)u8;
	u2 = (uint2)u8;
	i8 = (int8)u8;
	
	uint8 ullMax, ullMin, ullZero;
	i8tmp = LLONG_MAX;
	ullMax = *( (uint8*)&i8tmp) ; 
	i8tmp = LLONG_MIN;
	ullMin = *( (uint8*)&i8tmp) ; 
	i8tmp = -1;
	ullZero = *( (uint8*)&i8tmp) ; 
	
	printf("\ni8 bits  MAX: %llx  -1: %llx  MIN: %llx\n\n", 
			 ullMax, ullZero, ullMin);
	
	printf("\nu8: %llx,  u1: %hhx,  u2: %hx,  i8: %lld\n\n", u8, b1, u2, i8);
	
	for(i=0; i<8; i++)
	{
		pByteU = (byte*)( &u8) + i;	
		pByte = (byte*)( &i8) + i;	
		
		printf("pBU: %p,  pBI: %p,  bU: %hhx,  bI %hhx\n", 
				  pByteU, pByte, *pByteU, *pByte);
		
	}
	printf("\n");
	
	
	f8 = (float8)u8;
	printf("Casting to direct to float8: u8: %llx, f8: %e\n\n", u8, f8);
	
	for(i=0; i<8; i++)
	{
		pByteU = (byte*)( &u8) + i;	
		pByte = (byte*)( &f8) + i;	
		
		printf("pBU: %p,  pBF: %p,  bU: %hhx,  bF %hhx\n", 
				  pByteU, pByte, *pByteU, *pByte);
		
	}
	printf("\n");
	
	
	f8 = * ( (double*) (&u8) );
	
	printf("Casting to float8 via pointer: u8:  %llx, f8: %e\n\n", u8, f8);
	
	for(i=0; i<8; i++)
	{
		pByteU = (byte*)( &u8) + i;	
		pByte = (byte*)( &f8) + i;	
		
		printf("pBU: %p,  pBF: %p,  bU: %hhx,  bF %hhx\n", 
				  pByteU, pByte, *pByteU, *pByte);
		
	}
	
	
	
	return 0;
}
