#define _POSIX_C_SOURCE 200112

#ifdef GSE_POSIX_THREADS
#include <pthread.h>
#endif

#include <limits.h>
#include <stdio.h>


struct two {
  long long int nVal; 
  char* sName;
};


int main(int argc, char** argv){
	int i;
			
	struct two ary[] = {
		{SSIZE_MAX, "SSIZE_MAX"},
		{LLONG_MIN, "LLONG_MIN"},
		{LONG_MIN, "LONG_MIN"},
		{INT_MIN, "INT_MIN"},
		{SHRT_MIN, "SHRT_MIN"},
		{SCHAR_MIN, "SCHAR_MIN"},
		{SCHAR_MAX, "SCHAR_MAX"},
		{UCHAR_MAX, "UCHAR_MAX"},
		{SHRT_MAX, "SHRT_MAX"},
		{USHRT_MAX, "USHRT_MAX"},	
		{INT_MAX, "INT_MAX"},
		{UINT_MAX, "UINT_MAX"},
		{LONG_MAX, "LONG_MAX"},
		{ULONG_MAX, "ULONG_MAX"},
		{LLONG_MAX, "LLONG_MAX"}
		/* {ULLONG_MAX, "ULLONG_MAX"}, */ /* handle special */
	};

	for(i = 0; i < 12; i++)
		fprintf(stdout, "%10s: %20lld   0x%016llx\n", ary[i].sName,
				  ary[i].nVal, ary[i].nVal);
	
	fprintf(stdout, "%10s: %20llu   0x%016llx\n", "ULLONG_MAX", 
			  ULLONG_MAX, ULLONG_MAX);
	
	return 0;
}


/* Output values on Linux x86_64:

 SSIZE_MAX:  9223372036854775807   0x7fffffffffffffff
 LLONG_MIN: -9223372036854775808   0x8000000000000000
  LONG_MIN: -9223372036854775808   0x8000000000000000
   INT_MIN:          -2147483648   0xffffffff80000000
  SHRT_MIN:               -32768   0xffffffffffff8000
 SCHAR_MIN:                 -128   0xffffffffffffff80
 SCHAR_MAX:                  127   0x000000000000007f
 UCHAR_MAX:                  255   0x00000000000000ff
  SHRT_MAX:                32767   0x0000000000007fff
 USHRT_MAX:                65535   0x000000000000ffff
   INT_MAX:           2147483647   0x000000007fffffff
  UINT_MAX:           4294967295   0x00000000ffffffff
  LONG_MAX:  9223372036854775807   0x7fffffffffffffff
 ULONG_MAX:                   -1   0xffffffffffffffff
 LLONG_MAX:  9223372036854775807   0x7fffffffffffffff
ULLONG_MAX: 18446744073709551615   0xffffffffffffffff

*/

/*  Output values on Linux i686

 SSIZE_MAX:           2147483647   0x000000007fffffff
 LLONG_MIN: -9223372036854775808   0x8000000000000000
  LONG_MIN:          -2147483648   0xffffffff80000000
   INT_MIN:          -2147483648   0xffffffff80000000
  SHRT_MIN:               -32768   0xffffffffffff8000
  SHRT_MAX:                32767   0x0000000000007fff
 USHRT_MAX:                65535   0x000000000000ffff
   INT_MAX:           2147483647   0x000000007fffffff
  UINT_MAX:           4294967295   0x00000000ffffffff
  LONG_MAX:           2147483647   0x000000007fffffff
 ULONG_MAX:           4294967295   0x00000000ffffffff
 LLONG_MAX:  9223372036854775807   0x7fffffffffffffff
ULLONG_MAX: 18446744073709551615   0xffffffffffffffff

*/
