/* Test generating lib objects */
#define _POSIX_C_SOURCE 200112

#ifdef GSE_POSIX_THREADS
#include <pthread.h>
#endif

#include "../rpwgse/Gse.h"


int main(int argc, char** argv){
	bytebuf_t buf;
	GseBlock* pBlock;
	except_t* pExc;
	
	/* We want to catch stream encode/decode errors, but not others */
	static const except_id_t catch_spec[] = { 
		{GSE_XCEPT, GSE_XDECODE}, {GSE_XCEPT, GSE_XENCODE}
	};
	
	gse_thread_init(0, NULL);
	
	except_try_push(catch_spec, 2, &pExc);
	
	if(pExc == NULL){ 
		/* Normal actions */
		buf.len = 8;
		buf.ptr = (byte*) gse_calloc(buf.len, 1);
		buf.ptr[1] = 1;
		pBlock = new_GseBlock(const_bytebuf(buf), 0);
	}
	else{
		/* error handling */
		fprintf(stderr,"%s\nAhem! Well moving along...\n\n",except_message(pExc));
	}
	
	except_try_pop();
	
	
	/* Now lets trigger an unhandled exception */
	except_try_push(catch_spec, 2, &pExc);
	
	if(pExc == NULL){ 
		/* Normal actions */
		void* pTooBig;
#if __SIZEOF_LONG__ == 8
		pTooBig = gse_malloc(4398046511104U);  /* 4-Tera */
#else
		pTooBig = gse_malloc(4294967295U);     /* 4-Gigs */
#endif
	}
	else{
		/* error handling */
		fprintf(stderr,"%s\nHey its just a encode/decode error.\n",
				  except_message(pExc));
	}
 	
	except_try_pop();
 
 	return 0;
}
