/* Testing Return values of various timeof day calls */
#define _POSIX_C_SOURCE 200112

#ifdef GSE_POSIX_THREADS
#include <pthread.h>
#endif

#include "../rpwgse/GseInit.h"
#include "../rpwgse/GseTime.h"

int main(int argc, char** argv)
{
	struct timeval tv;
	char buf[40];
	struct tm* pTm;
	
	gse_thread_init(GSE_NOTICE, NULL);
	
	if(gettimeofday(&tv, NULL) != 0){
		fprintf(stderr, "Error calling gettimeofday\n");
		return 2;
	}
	
	printf("Local Time: %s\n", gse_tv2iso_local_s(&tv, GSE_MICROSECS, buf, 40));
	printf("UTC Time:   %s\n", gse_tv2iso_gm_s(&tv, GSE_MICROSECS, buf, 40));
	
	pTm = gse_gmtime(&(tv.tv_sec));
	pTm = gse_localtime(&(tv.tv_sec));
	
	gse_str2tv_gm("1999-12-31T23:59:59.666", &tv, true);
	
	printf("gse_timestr2tv(\"1999-12-31T23:59:59.666\"): %ld %ld\n", tv.tv_sec,
			  tv.tv_usec);
	
	printf("gse_tv2iso_gm(tv): %s\n", gse_tv2iso_gm(&tv, GSE_MICROSECS));
	
	return 0;
}


/* 319-330-0226 */
		
