# Common Definitions #########################################################

# Program and Related Files #################################################

SRV_SRCS = JnoPhaser.c jno_spice.c HskFineAdj.c SrvRower.c SrvRowWriter.c \
 SrvCalib.c SrvCalTbl.c caldir_util.c waves_pds_mksrv.c 

BST_SRCS = waves_pds_mkbst.c jno_spice.c JnoPhaser.c HskFineAdj.c  \
 BstCalTbl.c BstCalib.c BstRowWriter.c caldir_util.c
 
L2SPEC_SRCS = waves_pds_l2specrdr.c HskFineAdj.c jno_spice.c

#PDS_CFG_IN = WAV_CAL_ATTN_V00.CSV WAV_CAL_SRV_HFR_HI_PROP_V00.CSV \
# WAV_CAL_SRV_HFR_LO_PROP_V00.CSV  WAV_CAL_SRV_LFR_HI_PROP_V00.CSV \
# WAV_CAL_SRV_LFR_LO_N_V00.CSV WAV_CAL_SRV_HFR_HI_44_V00.CSV \
# WAV_CAL_SRV_HFR_LO_44_V00.CSV WAV_CAL_SRV_LFR_HI_E_V00.CSV \
# WAV_CAL_SRV_LFR_LO_B_V00.CSV WAV_CAL_SRV_LFR_LO_PROP_V00.CSV \
# WAV_CAL_SRV_HFR_HI_45_V00.CSV WAV_CAL_SRV_HFR_LO_45_V00.CSV \
# WAV_CAL_SRV_LFR_HI_N_V00.CSV WAV_CAL_SRV_LFR_LO_E_V00.CSV \
# WAV_CAL_BST_DIRECT_V00.CSV WAV_CAL_BST_MIXED_V00.CSV

SRV_OBJS = $(patsubst %.c, $(BUILD_DIR)/%.o, $(SRV_SRCS))
BST_OBJS = $(patsubst %.c, $(BUILD_DIR)/%.o, $(BST_SRCS))
L2SPEC_OBJS = $(patsubst %.c, $(BUILD_DIR)/%.o, $(L2SPEC_SRCS))

# INSTALL_CFG = $(patsubst %, $(INST_ETC)/pds/%, $(PDS_CFG_IN))

# Flags ######################################################################

WARNFLAGS = -Wall -Werror
INCFLAGS = -I$(INST_INC) -I$(CSPICE_DIR)/include
WARNFLAGS = -Wall -Werror
DEFINES = -DCFG=$(INST_ETC)

CFLAGS = -fexceptions -rdynamic -fPIC -ggdb -std=c99 \
 $(INCFLAGS) $(WARNFLAGS) $(DEFINES) -DGSE_POSIX_THREADS -DDEBUG

CC=gcc

STATIC_LIBS=$(CSPICE_LIB) $(INST_NAT_LIB)/libjwaves_t.a

#LFLAGS = -lefence -L$(LIB) -lrpwgse_t -lpthread -ldl -lm
LFLAGS = -L$(INST_NAT_LIB) -lrpwgse_t -lpthread -ldl -lm 

# Pattern Rules #############################################################

# Generic pattern rule for generating dependency makefiles
$(BUILD_DIR)/%.d:src/%.c | $(BUILD_DIR)
	@echo "Generating $@"
	set -e; rm -f $@; \
	$(CC) -MM $(CFLAGS) $< > $@.tmp; \
	sed 's|$*.o|$(BUILD_DIR)/& $@|g' $@.tmp > $@; \
	rm -f $@.tmp

# Pattern rule for PDS config files (Gone, CFG files are to be handled manually)
#$(CFG)/pds/%:cfg/%
#	if [ ! -e $(CFG) ]; then mkdir -p $(CFG)/pds; chmod g+w $(CFG)/pds; fi
#	cp $< $@
#	chmod g+w $@


# Pattern rule for program files
$(BUILD_DIR)/%.o:src/%.c | $(BUILD_DIR)
	$(CC) $(CFLAGS) -c $< -o $@

# Generic Pattern rule for installing exec's
$(INST_NAT_BIN)/%:$(BUILD_DIR)/%
	install -D -m 775 $< $@
	
	
# Explicit Rules #############################################################

build:$(BUILD_DIR)/waves_pds_mksrv $(BUILD_DIR)/waves_pds_mkbst \
 $(BUILD_DIR)/waves_pds_l2specrdr

$(BUILD_DIR)/waves_pds_mksrv:$(SRV_OBJS)
	$(CC) $(CFLAGS) $^ $(LFLAGS) $(STATIC_LIBS) -o $@

$(BUILD_DIR)/waves_pds_mkbst:$(BST_OBJS)
	$(CC) $(CFLAGS) $^ $(LFLAGS) $(STATIC_LIBS) -o $@

$(BUILD_DIR)/waves_pds_l2specrdr:$(L2SPEC_OBJS)
	$(CC) $(CFLAGS) $^ $(LFLAGS) $(STATIC_LIBS) -ldas -o $@
	
$(BUILD_DIR):
	if [ ! -e "$(BUILD_DIR)" ]; then mkdir -p $(BUILD_DIR); fi

install: $(INST_NAT_BIN)/waves_pds_mksrv $(INST_NAT_BIN)/waves_pds_mkbst \
 $(INST_NAT_BIN)/waves_pds_l2specrdr

	
# Auto make and grab the dependencies
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
-include $(SRV_OBJS:.o=.d)
-include $(BST_OBJS:.o=.d)
endif
endif

distclean:
	rm -r -f $(BUILD_DIR)

clean:
	rm $(BUILD_DIR)/*.o $(BUILD_DIR)/*.d
