/** @file HskFineAdj.h */
#ifndef _HskFineAdj_H_
#define _HskFineAdj_H_

#include <stdio.h>

#include <rpwgse/GseTypes.h>
#include <rpwgse/GsePkt.h>

#ifdef __cplusplus
extern "C" {
#endif

/*****************************************************************************/

typedef struct fine_time{
	int4 nSclk;
	uint2 uFine;
} fine_time_t;


#define S fines_list
#define C FinesList
#define I fine_time_t

#include <rpwgse/listTplt.h>

#undef I
#undef C
#undef S


/*****************************************************************************/
/* This object provides fine time adjustments for a given sclk */

typedef struct hsk_fine_adj{

	/** Get a sclk adjustment, modifies it's argument, if true is 
	    returned, remembers last lookup since the next one is
		 probably close by. */
	bool (*adjust)(struct hsk_fine_adj* pThis, float8* pSclk);

	/** Diagnostic, print fine times */
	void (*prnFines)(struct hsk_fine_adj* pThis, FILE* pOut);
	
	/** Destructor */
	void (*del)(void* vpThis);

	FinesList* _pList;
	
	const fine_time_t* _pCur;
	const fine_time_t* _pNext;

} HskFineAdj;

/* Constructor */
HskFineAdj* new_HskFineAdj(const char* sGroup, const char* sBeg,
                           const char* sEnd);

#ifdef __cplusplus
}
#endif

#endif /* _HskFineAdj_H_ */
