/** @file JnoSpice.h */
#ifndef _JnoSpice_H_
#define _JnoSpice_H_

#include <rpwgse/GseTime.h>

#ifdef __cplusplus
extern "C" {
#endif

/** Initialize Spice, or throw an exception */
void jno_spice_init(const char* sFurnish);

/** Convert a sclk to an scet string YYYY-DDDTHH:MM:SS.SSS using spice kernels */
char* jno_sclk2str(float8 dSclk, char* sScet, size_t nLen);

/** Convert a sclk to an SCET cal time using spice kernels */
void jno_sclk2ct(float8 dSclk, gse_caltime_t* pCt);

/** Convert an SCET string to a juno sclk using spice kernels */
float8 jno_str2sclk(const char* sScet);

/** Convert an SCET cal time to a SCLK using spice kernels */
float8 jno_ct2sclk(const gse_caltime_t* pCt);

/* Bounce spice errors to an exception, if failed_c indicates a problem */
void jno_spice_check();

#ifdef __cplusplus
}
#endif

#endif /* _JnoSpice_H_ */
