#define _POSIX_C_SOURCE 200112

#ifdef GSE_POSIX_THREADS
#include <pthread.h>
#endif

#include <daslib.h>
#include <das_cli.h>

const char* g_sDesc = 
"Reads Juno Level 2 datasets and outputs time-amplitude waveforms as a"
"Qstream\n";

const char* g_sFooter = 
"See Also:\n"
"     waves_pds_l2specrdr\n"
"Maintainer:\n"
"     Chris Piker <chris-piker@uiowa.edu>\n\n";

int main(int nArgs, char** sArgs){
	
	int byr, bmon, bdom, bhr, bmin; double bsec;
	int eyr, emon, edom, ehr, emin; double esec;
	
	DasSelector sels[] = {
		
		{"scet", timept_t, 0, (const char* []){OP_GE, OP_LT, NULL},
	    "Spacecraft Event Time"},
				
		{"dataset", string_t, ENUM, (const char*[]){"burst_lfr_b", 
		 "burst_lfr_lo", "burst_lfr_hi", "burst_wbr_lo", NULL}, 
		 "Select the type of L2 data to output."},
		
		{"level", string_t, ENUM|OPTIONAL, 
		 (const char*[]){"error","warning","info","debug",NULL},
	    "The logging level on the server, this output is not directly available"
		 " to remote clients"},
		
		NULL
	}
	
	DasOutput outs
	
	gse_thread_init(GSE_INFO, NULL);
	
	das_parsecmdline(nArgs, sArgs, sels, outs, g_sDesc, g_sFooter);
	
	das_get_seltime(sels, "scet", OP_BEG, 
	
	
	
	
	return 0;	
}
